﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Add a reference to System.Management.
using System.Management;

namespace howto_number_of_processors
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int num_physical_processors, num_cores, num_logical_processors;
            GetProcessorCounts(out num_physical_processors, out num_cores, out num_logical_processors);
            txtPhysicalProcessors.Text = num_physical_processors.ToString();
            txtCores.Text = num_cores.ToString();
            txtLogicalProcessors.Text = num_logical_processors.ToString();
        }

        // Return the numbers of physical processors, cores,
        // and logical processors.
        private void GetProcessorCounts(out int num_physical_processors,
            out int num_cores, out int num_logical_processors)
        {
            string query;
            ManagementObjectSearcher searcher;

            // Get the number of physical processors.
            num_physical_processors = 0;
            query = "SELECT * FROM Win32_ComputerSystem";
            searcher = new ManagementObjectSearcher(query);
            foreach (ManagementObject sys in searcher.Get())
                num_physical_processors =
                    int.Parse(sys["NumberOfProcessors"].ToString());

            // Get the number of cores.
            query = "SELECT * FROM Win32_Processor";
            num_cores = 0;
            searcher = new ManagementObjectSearcher(query);
            foreach (ManagementObject proc in searcher.Get())
                num_cores += int.Parse(proc["NumberOfCores"].ToString());

            num_logical_processors = Environment.ProcessorCount;
        }
    }
}
